/*
	< ---------- START fields ---------- >
	
	fields = {
		cont	: <html-object>
		info	: <message>,
		erro	: <message>,
		vrrf	: <message>,
		dprt	: <departure>[]
	}
	
	<message> = {
		self	: <html-object>,
		ttle	: <html-object>,
		msge	: <html-object>
	}

	<departure> = {
		self	: <html-object>,
		cont	: <html-object>,
		line	: <html-object>,
		name	: <html-object>,
		sttn	: [
			{
				self	: <html-object>,
				time	: <html-object>,
				dlay	: <html-object>,
				name	: <html-object>
			}
		]
	}
	
	< ---------- END fields ---------- >
*/

this.loaded = function(panel, config) {
	console.log("departures: register with config [" + config + "]");
	// TODO load config
	var
		tplDeparture	= $(panel).find('template[data-departure]').html(),
		tplStop			= $(panel).find('template[data-stop]').html(),
		tplMsg			= $(panel).find('template[data-msg]').html(),
		fields			= generate(config, 3, 20, tplDeparture, tplStop, tplMsg);
	
	buildDOM(config, fields);
	
	$(panel).empty().append(fields.cont);

	//var u = function() {
	//	console.log("departures: get data [" + config + "]");
	//	$.get("panels/departure/departures.php?config=" + config , function(decodedData) {
	//		update(decodedData, fields);
	//	});
	//};
	//setInterval(u, 60000);

	var r = function() {
		resize(panel, config, fields.cont);
	};
	$(window).resize(r);
	
	//var worker = new Worker('js/worker/WorkerDeparture.js');
	var worker = new Worker('panels/departure/worker.js');
	
	worker.addEventListener('message', function(e) {
		var data = e.data;
		update(data, fields, config);
	}, false);
	
	//worker.postMessage([{cmd:"loadConfig", params:[config]},{cmd:"start"}]);
	worker.postMessage({cmd:"loadConfig", params:[config]});
	worker.postMessage({cmd:"start"});

	//u();
	r();
}

var update = function(decodedData, fields, config) {
		
	console.log("departures: check vrrf errors [" + config + "]");
	if (!!decodedData.errors) {
		var msg = "";
		for (var i in decodedData.errors) {
			if (decodedData.errors[i]) {
				msg += (msg.lenth > 0 ? '\r\n' : '') + i + ': ' + decodedData.errors[i]
			}
		}
		$(fields.vrrf.ttle).html('VRRF - Error');
		$(fields.vrrf.msge).html(msg);
	} else {
		$(fields.vrrf.ttle).html('');
		$(fields.vrrf.msge).html('');
		$(fields.vrrf.msge).css("display", "none");
	}
	
	console.log("departures: check error [" + config + "]");
	if (!!decodedData.error) {
		$(fields.erro.ttle).html('InfoBoard - Error');
		$(fields.erro.msge).html(decodedData.error);
	} else {
		$(fields.erro.ttle).html('');
		$(fields.erro.msge).html('');
		$(fields.erro.msge).css("display", "none");
	}
	
	console.log("departures: check information [" + config + "]");
	if (!!decodedData.info) {
		$(fields.info.ttle).html('Information');
		$(fields.info.msge).html(decodedData.info);
		//$(fields.info.msge).css("display", "");
	} else {
		$(fields.info.ttle).html('');
		$(fields.info.msge).html('');
		//$(fields.info.msge).css("display", "none");
	}
	
	console.log("departures: updating elements [" + config + "]");
	if (!!decodedData.lines) {
		for (var i = 0; i < 20; ++i) {
			var 
				actDep	= fields.dprt[i],
				strDep	= decodedData.lines[i];
			if (!strDep) {
				$(actDep.self).css("display", "none");
				$(actDep.line).html('');
				$(actDep.name).html('');
				for (var j = 0; j < 3; ++j) {
					var actStn = actDep.sttn[j];
					$(actStn.self).css("display", "none");
					$(actStn.time).html('');
					$(actStn.name).html('');
					//$(actStn.info.self).css("display", "none");
					//$(actStn.info.msge).html('');
				}
			} else {
				$(actDep.self).css("display", "");
				$(actDep.line).html(strDep.line.toUpperCase());
				$(actDep.name).html(strDep.destination.replace("Dortmund ", ""));
				for (var j = 0; j < 3; ++j) {
					var 
						actStn = actDep.sttn[j],
						strStn = strDep.stops[j];
					if (!strStn) {
						$(actStn.self).css("display", "none");
						$(actStn.time).html('');
						$(actStn.dlay).html('');
						$(actStn.name).html('');
					} else {
						$(actStn.self).css("display", "");
						$(actStn.time).html(strStn.time);
						$(actStn.name).html(strStn.name.replace("Dortmund - ", ""));
						if (strStn.cancel == 1) {
							$(actStn.name).css("text-decoration", "outline");
						} else {
							$(actStn.name).css("text-decoration", "");
						}
							
						if (strStn.delay > 0) {
							$(actStn.dlay).html('+' + strStn.delay);
						} else {
							$(actStn.dlay).html('');
						}
					}
				}
			}
		}
	}
}

var resize = function(panel, config, cont) {
	var
		scale		= $(panel).innerHeight() / 100,
		lineHed		= $(cont).find('[data-transport]'),
		lineLin		= $(lineHed).find('[data-line]'),
		lineStp		= $(cont).find('[data-stop]'),
		infoTtl		= $(cont).find('[data-title]'),
		infoMsg		= $(cont).find('[data-message]'),
		stopTme		= $(lineStp).find('[data-time]'),
		stopDly		= $(lineStp).find('[data-delay]'),
		// setze größen der schriften mit scale * n wobei n in prozent von panelhöhe
		lineHedH	= scale * 5,		// überschriften der linien
		lineStpH	= scale * 4,		// haltestellen der linien
		infoTtlH	= scale * 6,		// überschriften der informationen
		infoMsgH	= scale * 5,		// die eigentliche nachricht der information
		// berechne string breite
		timeWidth	= getStringWidth((lineStpH-2), "00:00"),
		delayWidth	= getStringWidth((lineStpH-2), "+00");
	
	// setze linien überschriften größe
	$(lineHed).css('height', lineHedH + 'px');
	$(lineHed).css('fontSize', (lineHedH-2) + 'px');
	$(lineHed).css('lineHeight', lineHedH + 'px');
	$(lineLin).css('width', (timeWidth+delayWidth) + 'px');

	// setze linien haltestellen größe
	$(lineStp).css('height', lineStpH + 'px');
	$(lineStp).css('fontSize', (lineStpH-2) + 'px');
	$(lineStp).css('lineHeight', lineStpH + 'px');
	
	// setze zeit und delay breite
	$(stopTme).css('width', timeWidth + 'px');
	$(stopDly).css('width', delayWidth + 'px');
	
	// setze info überschriften größe
	$(infoTtl).css('height', infoTtlH + 'px');
	$(infoTtl).css('fontSize', (infoTtlH-2) + 'px');
	$(infoTtl).css('lineHeight', infoTtlH + 'px');

	// setze info nachricht größe
	$(infoMsg).css('height', infoMsgH + 'px');
	$(infoMsg).css('fontSize', (infoMsgH-2) + 'px');
	$(infoMsg).css('lineHeight', infoMsgH + 'px');
}

var getStringWidth = function(fontSize, string) {
	var 
		o = $('<div>' + string + '</div>')
		.css({'position': 'absolute', 'float': 'left', 'white-space': 'nowrap', 'visibility': 'hidden', 'font-family': 'display', 'fontSize': fontSize + 'px'})
		.appendTo($('body')),
		w = o.width();
	o.remove();
	return w;
}

var generate = function(config, stations, departs, tplDeparture, tplStop, tplMsg) {
	console.log("departures: generating structure [" + config + "]");
	var
		buffer	= null,
		fields	= {
			cont	: null,
			info	: null,
			erro	: null,
			vrrf	: null,
			dprt	: []
		};
		
	// container
	fields.cont = document.createElement('DIV');
	$(fields.cont).attr("data-departure-view", "");

	// info
	buffer = $(tplMsg).clone();
	fields.info		= {
		self	: buffer,
		ttle	: $(buffer).find('[data-title]'),
		msge	: $(buffer).find('[data-message]')
	}
	$(buffer).css("display", "none");

	// error
	buffer = $(tplMsg).clone();
	fields.erro		= {
		self	: buffer,
		ttle	: $(buffer).find('[data-title]'),
		msge	: $(buffer).find('[data-message]')
	}
	$(buffer).css("display", "none");

	// vrrf error
	buffer = $(tplMsg).clone();
	fields.vrrf		= {
		self	: buffer,
		ttle	: $(buffer).find('[data-title]'),
		msge	: $(buffer).find('[data-message]')
	}
	$(buffer).css("display", "none");
	
	// departures
	for (var i = 0; i < departs; ++i) {
		buffer = $(tplDeparture).clone();		
		var dataBuffer = {
			self	: buffer,
			cont	: buffer.find('[data-stops]'),
			line	: $(buffer).find('[data-transport] [data-line]'),
			name	: $(buffer).find('[data-transport] [data-name]'),
			sttn	: []
		}
		for (var j = 0; j < stations; ++j) {
			buffer = $(tplStop).clone();
			var infoBuffer = $(buffer).find('[data-info]');
			dataBuffer.sttn.push({
				self	: buffer,
				time	: $(buffer).find('[data-time]'),
				dlay	: $(buffer).find('[data-delay]'),
				name	: $(buffer).find('[data-name]')
			});
		}
		fields.dprt.push(dataBuffer);
	}
	return fields;
}

var buildDOM = function(config, fields) {
	console.log("departures: building dom [" + config + "]");
	var elements = [];	
	elements.push(fields.info.self);
	elements.push(fields.erro.self);
	elements.push(fields.vrrf.self);
	for (var i = 0; i < fields.dprt.length; ++i) {
		var 
			buf = fields.dprt[i],
			elB = [];
		for (j = 0; j < buf.sttn.length; ++j) {
			elB.push(buf.sttn[j].self);
		}
		$(buf.cont).append(elB);
		elements.push(buf.self);
	}
	$(fields.cont).append(elements);
}
